local Realms = {
	USP = {
		"Aerie Peak",
		"Anvilmar",
		"Arathor",
		"Antonidas",
		"Azuremyst",
		"Baelgun",
		"Blade's Edge",
		"Bladefist",
		"Bronzebeard",
		"Cenarius",
		"Darrowmere",
		"Draenor",
		"Dragonblight",
		"Echo Isles",
		"Galakrond",
		"Gnomeregan",
		"Hyjal",
		"Kilrogg",
		"Korialstrasz",
		"Lightbringer",
		"Misha",
		"Moonrunner",
		"Nordrassil",
		"Proudmoore",
		"Shadowsong",
		"Shu'Halo",
		"Silvermoon",
		"Skywall",
		"Suramar",
		"Uldum",
		"Uther",
		"Velen",
		"Windrunner",
		"Blackrock",
		"Blackwing Lair",
		"Bonechewer",
		"Boulderfist",
		"Coilfang",
		"Crushridge",
		"Daggerspine",
		"Dark Iron",
		"Destromath",
		"Dethecus",
		"Dragonmaw",
		"Dunemaul",
		"Frostwolf",
		"Gorgonnash",
		"Gurubashi",
		"Kalecgos",
		"Kil'Jaeden",
		"Lethon",
		"Maiev",
		"Nazjatar",
		"Ner'zhul",
		"Onyxia",
		"Rivendare",
		"Shattered Halls",
		"Spinebreaker",
		"Spirestone",
		"Stonemaul",
		"Stormscale",
		"Tichondrius",
		"Ursin",
		"Vashj",
		"Blackwater Raiders",
		"Cenarion Circle",
		"Feathermoon",
		"Sentinels",
		"Silver Hand",
		"The Scryers",
		"Wyrmrest Accord",
		"The Venture Co",
	},

	USM = {
		"Azjol-Nerub",
		"Doomhammer",
		"Icecrown",
		"Perenolde",
		"Terenas",
		"Zangarmarsh",
		"Kel'Thuzad",
		"Darkspear",
		"Deathwing",
		"Bloodscalp",
		"Nathrezim",
		"Shadow Council",
	},

	USC = {
		"Aggramar",
		"Alexstrasza",
		"Alleria",
		"Blackhand",
		"Borean Tundra",
		"Cairne",
		"Dawnbringer",
		"Draka",
		"Eitrigg",
		"Fizzcrank",
		"Garona",
		"Ghostlands",
		"Greymane",
		"Grizzly Hills",
		"Hellscream",
		"Hydraxis",
		"Kael'thas",
		"Khaz Modan",
		"Kul Tiras",
		"Madoran",
		"Malfurion",
		"Malygos",
		"Mok'Nathal",
		"Muradin",
		"Nesingwary",
		"Quel'Dorei",
		"Ravencrest",
		"Rexxar",
		"Runetotem",
		"Sen'Jin",
		"Staghelm",
		"Terokkar",
		"Thunderhorn",
		"Vek'nilash",
		"Whisperwind",
		"Winterhoof",
		"Aegwynn",
		"Agamaggan",
		"Akama",
		"Archimonde",
		"Azgalor",
		"Azshara",
		"Balnazzar",
		"Blood Furnace",
		"Burning Legion",
		"Cho'gall",
		"Chromaggus",
		"Detheroc",
		"Drak'tharon",
		"Drak'thul",
		"Frostmane",
		"Garithos",
		"Gul'dan",
		"Hakkar",
		"Illidan",
		"Korgath",
		"Laughing Skull",
		"Mal'Ganis",
		"Malorne",
		"Mug'thol",
		"Stormreaver",
		"Sargeras",
		"The Underbog",
		"Thunderlord",
		"Wildhammer",
		"Farstriders",
		"Kirin Tor",
		"Moon Guard",
		"Scarlet Crusade",
		"Sisters of Elune",
		"Thorium Brotherhood",
		"Emerald Dream",
		"Lightninghoof",
		"Maelstrom",
		"Twisting Nether",
	},

	USE = {
		"Area 52",
		"Arygos",
		"Bloodhoof",
		"Dalaran",
		"Drenden",
		"Durotan",
		"Duskwood",
		"Eldre'Thalas",
		"Elune",
		"Eonar",
		"Exodar",
		"Fenris",
		"Garrosh",
		"Gilneas",
		"Grizzly Hills",
		"Kargath",
		"Khadgar",
		"Llane",
		"Lothar",
		"Medivh",
		"Nazgrel",
		"Norgannon",
		"Shandris",
		"Stormrage",
		"Tanaris",
		"Thrall",
		"Trollbane",
		"Turalyon",
		"Uldaman",
		"Undermine",
		"Ysera",
		"Zul'jin",
		"Altar of Storms",
		"Alterac Mountains",
		"Andorhal",
		"Anetheron",
		"Anub'arak",
		"Arthas",
		"Auchindoun",
		"Black Dragonflight",
		"Bleeding Hollow",
		"Burning Blade",
		"Dalvengyr",
		"Demon Soul",
		"Eredar",
		"Executus",
		"Firetree",
		"Gorefiend",
		"Haomarush",
		"Jaedenar",
		"Lightning's Blade",
		"Mannoroth",
		"Magtheridon",
		"Scilla",
		"Shadowmoon",
		"Shattered Hand",
		"Skullcrusher",
		"Smolderthorn",
		"The Forgotten Coast",
		"Tortheldrin",
		"Warsong",
		"Ysondre",
		"Zuluhed",
		"Argent Dawn",
		"Earthen Ring",
		"Steamwheedle Cartel",
		"Ravenholdt",
	},

	OCE = {
		"Aman'Thul",
		"Caelestrasz",
		"Dath'Remar",
		"Khaz'goroth",
		"Nagrand",
		"Saurfang",
		"Barthilas",
		"Dreadmaul",
		"Frostmourne",
		"Gundrak",
		"Jubei'Thos",
		"Thaurissan",
	},

	LA = { "Quel'Thalas", "Drakkari", "Ragnaros" },

	BR = { "Goldrinn", "Gallywix", "Azralon", "Nemesis", "Tol Barad" },
}

local RegionNames = {
	USP = "US-P",
	USM = "US-M",
	USC = "US-C",
	USE = "US-E",
	OCE = "OCE",
	LA = "LAT",
	BR = "BR",
}

local RegionColors = {
	BR = "|cFF9b59b6",
	OCE = "|cFF3498db",
	LA = "|cFFc0392b",
}

local function RegisterButton(self)
	local resultID = self.resultID
	local leaderName = C_LFGList.GetSearchResultInfo(resultID).leaderName

	if not leaderName then
		return
	end

	local groupRealm = leaderName:match("-(.+)")

	if groupRealm then
		groupRealm = groupRealm:lower():gsub(" ", "")
	else
		groupRealm = GetRealmName():lower():gsub(" ", "")
	end

	local realmRegion = ""

	for region, regionRealms in pairs(Realms) do
		for _, realm in pairs(regionRealms) do
			if realm:lower():gsub(" ", "") == groupRealm then
				realmRegion = region
				break
			end
		end
	end

	local color = "|cFF1abc9c"

	color = RegionColors[realmRegion] or color

	self.ActivityName:SetFormattedText("%s%s|r %s", color, RegionNames[realmRegion], self.ActivityName:GetText())
end

local function LFGListSearchPanel_OnShow(self)
	local buttons = self.ScrollBox:GetFrames()
	for _, button in pairs(buttons) do
		if
			button
			and button.ActivityName
			and button.ActivityName:GetText()
			and button.ActivityName:GetText():sub(1, 1) ~= "["
			and button.ActivityName:GetText():sub(1, 1) ~= "|"
		then
			RegisterButton(button)
		end
	end
end

LFGListFrame.SearchPanel:HookScript("OnUpdate", LFGListSearchPanel_OnShow)

local function registerApplicant(self)
	local data = self:GetElementData()

	local name = C_LFGList.GetApplicantMemberInfo(data.id, 1)

	local playerRealm = name:match("-(.+)")

	if playerRealm then
		playerRealm = playerRealm:lower():gsub(" ", "")
	else
		playerRealm = GetRealmName():lower():gsub(" ", "")
	end

	local realmRegion

	for region, regionRealms in pairs(Realms) do
		for _, realm in pairs(regionRealms) do
			if realm:lower():gsub(" ", "") == playerRealm then
				realmRegion = region
				break
			end
		end
	end

	local color = "|cFF1abc9c"

	color = RegionColors[realmRegion] or color

	local label = self.Member1:CreateFontString()
	label:SetPoint("LEFT", self.Member1.Name, "RIGHT")
	label:SetFontObject("GameFontHighlight")
	label:SetText(string.format(" %s%s", color, RegionNames[realmRegion]:gsub("(-.+)", "")))
	label:SetTextScale(0.7)

	self.gfrLabel = label
end

local function LFGListApplicationViewer_OnShow(self)
	local buttons = self.ScrollBox:GetFrames()
	for _, button in pairs(buttons) do
		if button and not button.gfrLabel then
			registerApplicant(button)
		end
	end
end

LFGListFrame.ApplicationViewer:HookScript("OnUpdate", LFGListApplicationViewer_OnShow)
